﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim Broker As MqttBroker
	Dim client As MqttClient
	Private serializator As B4XSerializator
	Private connected As Boolean = False
	Private brokerStarted As Boolean = False
	Private users As List
	Private const ServerName As String = "Test1"
End Sub

Sub StartBroker
	Main.LogAdd("Starting MQTT broker")
	Broker.Initialize("", 51042)
	Broker.DebugLog = True
	users.Initialize
	Broker.Start
	brokerStarted = True
	Main.LogAdd("If you see no crash, then broker is started")
End Sub

Sub StartMonitorClient
	If Not(brokerStarted) Then StartBroker
	If connected Then StopMonitorClient 'then reinitialize and reconnect
	Main.LogAdd("Starting monitor client")
	client.Initialize("client", "tcp://127.0.0.1:51402", "Side0")
	Dim mo As MqttConnectOptions
	mo.Initialize("", "")
	'this message will be sent if the client is disconnected unexpectedly.
	mo.SetLastWill("all/disconnect", serializator.ConvertObjectToBytes(ServerName), 0, False)
	client.Connect2(mo)
End Sub

Sub client_Connected (Success As Boolean)
	Main.LogAdd($"Monitor connected: ${Success}"$)
	If Success Then
		connected = True
		client.Subscribe("all/#", 0)
		client.Publish2("all/connect", serializator.ConvertObjectToBytes(ServerName), 0, False)
	Else
		Main.LogAdd("Error connecting monitor")
	End If
End Sub

Sub StopMonitorClient
	If connected Then 
		connected = False
		client.Publish2("all/disconnect", serializator.ConvertObjectToBytes(ServerName), 0, False)
		client.Close
	End If
End Sub

Sub StopBroker
	If brokerStarted Then
		Broker.Stop
		brokerStarted = False
	End If
End Sub